function on.paint(gc)
	gc:setFont("sansserif","r",12)
	gc:setColorRGB(0,0,0)
	if not init then
		i = {"","","",""}
	a = 1
	end
	gc:drawString("Base converter",100,20)
	gc:drawString("|",97,48+25*a)
	gc:drawString("Input",10,50,"top")
	gc:drawString("Base In",10,75,"top")
	gc:drawString("Base Out",10,100,"top")
	gc:drawString("Output",10,125,"top")
	gc:setFont("sansserif","r",10)
	for j,k in ipairs(i) do 
		gc:drawString(k,100,48+25*j)
	end
	gc:setFont("sansserif","r",8)
	gc:drawString("by cyanophycean314",2,210)
end 

function on.charIn(key) 
	if string.len(i[a])<20 and a<4 then
		i[a] = i[a]..key 
		init = true
		platform.window:invalidate()
	end
end

function on.enterKey()
	if a < 4 then
		if i[a] ~= "" then 
			a = a + 1
		end
		if a == 4 then
			i[4] = eval(i[1],i[2],i[3])
		end
	end
	init = true
	platform.window:invalidate()
end

function eval(a,b,c)
	for num, peeps in ipairs({a,b,c}) do
		for nox, xon in ipairs(splitter(peeps)) do
			if not keyInString(xon, "1234567890qwertyuiopasdfghjklzxcvbnm") then
				return "ERROR - Unknown input"
			end
		end
	end
	if tonumber(b) > 36 or tonumber(c) > 36 then
		return "ERROR - BASE TOO HIGH"
	end
	if tonumber(b) <= 1 or tonumber(c) <= 1 then
		return "ERROR - BASE TOO LOW"
	end
	splitz = splitter(a)
	out1 = 0
	for e,f in ipairs(splitz) do
		num = ord(f)
		if tonumber(num) >= tonumber(b) then
			return "ERROR - Number is higher than base"			
		end
		out1 = out1 + num*b^(#splitz-e)
	end
	out2 = ""
	repeat
		out2 = oppord(out1 % c)..out2
		out1 = math.floor((out1-(out1 % c))/c)
	until out1 < tonumber(c)
	if out1 ~= 0 then
		out2 = oppord(tonumber(out1))..out2
	end
	return out2
end

function on.backspaceKey()
    i[a] = string.usub(i[a],0,string.len(i[a])-1)
    init = true
	platform.window:invalidate()
end

function splitter(abcd)
	tabstring = {}
	for k=1, string.len(abcd) do
		table.insert(tabstring,string.usub(abcd,k,k))
	end
	return tabstring
end

function on.tabKey()
	init = false
	platform.window:invalidate()
end
--88
function ord(bcd)
	if keyInString(bcd, "0123456789") then
		return bcd
	end
	for z,y in ipairs(splitter("abcdefghijklmnopqrstuvwxyz")) do
		if y == bcd then
			return z + 9
		end
	end
end

function keyInString(key, stringy)
	x = false
	for nox, xon in ipairs(splitter(stringy)) do
		x = x or xon == key
	end
	return x
end

function oppord(bcd)
	if bcd < 10 then
		return bcd
	elseif bcd >= 10 then
		return splitter("abcdefghijklmnopqrstuvwxyz")[bcd-9]
	end
end
